<template>
  <v-menu
    :offset="offset"
    :origin="origin"
    :location="location"
    :close-on-content-click="closeOnContentClick"
  >
    <template #activator="{ isActive, props }">
      <div v-bind="props">
        <slot name="activator" :is-active="isActive">
          <svn-pro-button text="Click" />
        </slot>
      </div>
    </template>
    
    <slot name="dropdown-block">
      <v-list
        :class="menuClass"
        :color="menuColor"
        :density="listDensity"
      >
        <template v-if="items?.length" v-for="(item, index) in items">
          <v-list-item
            v-if="!item?.show"
            :key="index"
            :value="item"
            :to="item?.to"
            :prepend-icon="item?.icon"
            :disabled="item?.disabled"
            @click="item?.onClick"
            :class="item?.error ? 'text-error' : 'text-onSurface'"
          >
            <svn-pro-text>
              {{ item?.title }}
            </svn-pro-text>
          </v-list-item>
        </template>
  
        <slot v-else name="dropdown" />
      </v-list>
    </slot>
  </v-menu>
</template>

<script setup>
import SvnProButton from '../button/SvnProButton.vue';

const props = defineProps({
  items: {
    type: Array,
    default: () => []
  },
  closeOnContentClick: {
    type: Boolean,
    default: true
  },
  offset: {
    type: Number,
    default: null
  },
  menuColor: {
    type: String,
    default: "primary"
  },
  listDensity: {
    type: String,
    default: "default"
  },
  origin: {
    type: String,
    default: "auto"
  },
  location: {
    type: String,
    default: "bottom"
  },
  menuClass: {
    type: String,
    default: undefined,
  }
})
</script>